#include <stdio.h>

void imprimeRetangulo (int base, int altura);
void imprimeTriangulo (int altura);
void imprimeRetanguloOco (int base, int altura);
void imprimePiramide (int altura);
void imprimeParalelogramo (int altura);

int main()
{
    int base = 1, altura = 1, opcao;
    do
    {
        printf ("\nDigite 1 para imprimir um Retangulo");
        printf ("\nDigite 2 para imprimir um Triangulo");
        printf ("\nDigite 3 para imprimir um Retangulo com interior vazio");
        printf ("\nDigite 4 para imprimir uma Piramide");
        printf ("\nDigite 5 para imprimir um Paralelogramo");
        printf ("\nDigite 0 para encerrar o programa\n");
        scanf ("%d", &opcao);
        if (opcao == 1 || opcao == 3) //se a opo escolhida foi um dos retngulos, pergunta-se o tamanho da base e da altura
        {
            printf ("Digite o tamanho da base: ");
            scanf ("%d", &base);
            printf ("Digite o tamanho da altura: ");
            scanf ("%d", &altura);
        }
        else if (opcao == 2 || opcao == 4 || opcao == 5) //se a opo escolhida foi o tringulo, pirmide ou paralelogramo, pergunta-se a altura
        {
            printf ("Digite o tamanho da altura: ");
            scanf ("%d", &altura);
        }
        if (altura <= 0 || altura >= 50 || base <= 0 || base >= 50) //condio de validade da base e da altura
        {
            printf ("\nTamanho(s) Invalido(s)\n");
        }
        else
        {
            switch (opcao)
            {
                case 0: break; //se for digitado 0, encerra o programa
                case 1: {
                            imprimeRetangulo (base, altura); //chama a funo que imprime o retngulo
                            break;
                        }
                case 2: {
                            imprimeTriangulo (altura); //chama a funo que imprime o tringulo
                            break;
                        }
                case 3: {
                            imprimeRetanguloOco (base, altura); //chama a funo que imprime o retngulo com interior vazio
                            break;
                }
                case 4: {
                            imprimePiramide (altura); //chama a funo que imprime a pirmide
                            break;
                        }
                case 5: {
                            imprimeParalelogramo (altura); //chama a funo que imprime o paralelogramo
                            break;
                        }
                default:{
                            printf ("\nOpcao invalida!"); //se no for nenhuma das seis opes, imprime opo invlida
                        }
            }
        }
    }
    while (opcao != 0);

    return 0;
}

void imprimeRetangulo (int base, int altura) //funo que imprime o retngulo
{
    int linha, coluna;
    for (linha = 1; linha <= altura; linha++) //lao que pula uma linha at que a linha seja igual a altura
    {

        for (coluna = 1; coluna <= base; coluna++) //lao que imprime os asteriscos at que seja igual ao tamanho da base
        {
            printf("*"); //imprime os asteriscos
        }
        printf ("\n"); //pula a linha
    }
}

void imprimeTriangulo (int altura) //funo que imprime o tringulo
{
    int linha, coluna;
    for (linha = 1; linha <= altura; linha++) //lao que pula uma linha at que a linha seja igual a altura
    {
        for (coluna = 1; coluna <= linha; coluna++) //lao que imprime os asteriscos at que seja igual ao nmero da linha
        {
            printf ("*"); //imprime os asteriscos
        }
        printf("\n"); //pula a linha
    }
}

void imprimeRetanguloOco (int base, int altura) //funo que imprime o retngulo com o interior vazio
{
    int linha, coluna;
    for (linha = 1; linha <= altura; linha++) //lao que pula uma linha at que a linha seja igual a altura
    {
        for (coluna = 1; coluna <= base; coluna++) //lao que imprime os asteriscos e espaos at que seja igual ao tamanho da base
        {
            if (linha == 1 || linha == altura) //se a linha for a primeira ou a ltima, imprime asteriscos
            {
                printf ("*"); //imprime asteriscos
            }
            else //seno, s vai imprimir asteriscos na primeira e na ltima coluna. Nas outras sero impressos espaos
            {
                if (coluna == 1 || coluna == base)
                {
                    printf ("*"); //imprime asteriscos
                }
                else
                {
                    printf (" "); //imprime espaos
                }
            }
        }
        printf ("\n");//pula a linha
    }
}

void imprimePiramide (int altura) //funo que imprime a pirmide
{
    int numEspacos, linha, aux;
    numEspacos = altura;
    for (linha = 1; linha <= altura; linha++, numEspacos--) //lao que pula uma linha at que a linha seja igual a altura
    {
        for (aux = 1; aux < numEspacos; aux++) //lao que imprime o nmero de espaos antes do primeiro asterisco
        {
            printf (" ");
        }
        for (aux = 0; aux < (2 * linha) - 1; aux++) //lao que imprime os asteriscos e laos da pirmide
        {
            if (aux % 2 == 0) //se aux for divisvel por 2, imprime um asterisco
            {
                printf ("*");
            }
            else //seno, imprime um espao
            {
                printf (" ");
            }
        }
        printf ("\n");//pula a linha
    }
}

void imprimeParalelogramo (int altura) //funo que imprime o paralelogramo
{
    int linha, coluna, aux1, aux2;
    aux2 = altura;
    for (linha = 1; linha <= altura; linha++) //laos que imprimem a parte superior do paralelogramo (igual ao tringulo)
    {
        for (coluna = 1; coluna <= linha; coluna++)
        {
            printf ("*");
        }
        printf("\n");
    }
    for (linha = altura - 1; linha >= 1; linha--, aux2--) //lao que pula a linha na parte inferior do paralelogramo e decrementa o aux2
    {
        for (aux1 = altura; aux1 >= aux2; aux1--) //enquanto o aux1 for maior ou igual que o aux2, imprime os espaos antes do asterisco
        {
        printf (" "); //imprime espao
        }
        for (aux1 = 1; aux1 < aux2; aux1++) //enquanto o aux1 for menor que o aux2, imprime asterisco
        {
            printf ("*");//imprime asteriscos
        }
        printf ("\n");//pula a linha
    }
}
